<?php

namespace Drupal\dynamic_routes\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Routing\RouteMatchInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Route controller for the report.
 */
class ReRouter extends ControllerBase {

  /**
   * The current user.
   *
   * @var mixed
   */
  protected $currentUser;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    // Use dependency injection, because it's the right thing to do.
    return new static(
      $container->get('current_user')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function __construct($current_user) {
    $this->currentUser = $current_user;
  }

  /**
   * Returns a renderable array for the report page.
   *
   * @param \Drupal\Core\Routing\RouteMatchInterface $route_match
   *   The route match.
   *
   * @return array
   *   The response.
   */
  public function content(RouteMatchInterface $route_match = NULL) {

    $newPath = preg_replace('/\/user\/current($|\/)/', '/user/' . $this->currentUser->id() . '$1', $route_match->getRouteObject()->getPath());
    xdebug_break();

    return new RedirectResponse($newPath);
  }

}
